#/bin/sh
#@***h* GPCPcdr_ECPd_ProcessAll.sh
#       Global Precipitation Climatology Project (GPCP)
#
# NAME
#   GPCPcdr_ECPd_ProcessAll.sh
#
# PURPOSE
#   This routine produces the daily GPCP NetCDF file.
#
# DESCRIPTION
# Executive Control Package - Daily
# Code to process several years of data. This code
# should be used to reprocess dailly data for 
# the whole period. 
# This code calls GPCPcdr_ECPd_Process1month.sh
# AUTHOR
#   Robert Adler, Mathew Sapiano, Jian-Jian Wang
#   University of Maryland College Park
#
# COPYRIGHT
#   THIS SOFTWARE AND ITS DOCUMENTATION ARE CONSIDERED TO BE IN THE PUBLIC
#   DOMAIN AND THUS ARE AVAILABLE FOR UNRESTRICTED PUBLIC USE. THEY ARE
#   FURNISHED "AS IS." THE AUTHORS, THE UNITED STATES GOVERNMENT, ITS
#   INSTRUMENTALITIES, OFFICERS, EMPLOYEES, AND AGENTS MAKE NO WARRANTY,
#   EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE SOFTWARE AND
#   DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
#   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL
#   SUPPORT TO USERS.
#
# HISTORY
# 1/2017 Initial Version prepared for NCEI
#
#@*****

#############################################
# flags for processing

flag_GPCPcdr_d1_GetInputFiles=1
flag_GPCPcdr_d2_GPROFv2004=0
flag_GPCPcdr_d4_CORR_G=1
flag_GPCPcdr_d4_ADJIR=1
flag_GPCPcdr_d4_CORR_T=1
flag_GPCPcdr_d4_FUSE2=1
flag_GPCPcdr_d4_WriteNC=1




#############################################
# Establish months to be processed

# Start year and month 
yyyy1=2013

# End year and month
yyyy2=2015


# Scroll through all years and months
AllYears=`seq $yyyy1 $yyyy2`
AllMonths=`seq -f "%02g" 1 12`

for yyyy in $AllYears; do
    for mm in $AllMonths; do

 	./GPCPcdr_ECPd_Process1month.sh $yyyy $mm $flag_GPCPcdr_d1_GetInputFiles $flag_GPCPcdr_d2_GPROFv2004 $flag_GPCPcdr_d4_CORR_G $flag_GPCPcdr_d4_ADJIR $flag_GPCPcdr_d4_CORR_T $flag_GPCPcdr_d4_FUSE2 $flag_GPCPcdr_d4_WriteNC

    done
done



