      program Main_GPCPcdr_d2_GPROFv2004
c     This program is the main entry way to run GPROF v2004 
c     This code simply reads a list of files and calls the 
c     subroutine to do the retrieval

      implicit none
      INCLUDE 'netcdf.inc'


      integer*4      strlen, Ninputs, inunit, ios
      integer*4      iyear, imonth
      character*256  GPROFPATH, file_list, input_file
      character*2    cmonth
      character*3    sat
      character*4    cyear
      logical*1      opn


c     ******************************************************
c     Setup and checks
      
c     Check the correct number of inputs were given
      Ninputs = iargc()
      if ( Ninputs .NE. 4 ) then
         WRITE(*,*) 'Error in Main_GPCPcdr_d2_GPROFv2004:'//
     &        ' Incorrect number of input arguments (should be 4)'
         STOP
      endif

C     Get arguments and set the length of the month in hours.
      call getarg(1, cyear)
      call getarg(2, cmonth)
      call getarg(3, sat)
      call getarg(4, GPROFPATH)

c     Convert month and year to numbers
      read(cyear, '(i10)' ) iyear
      read(cmonth, '(i10)' ) imonth



c     ******************************************************
c     Open list of files

      file_list="filelist.test"


C     check for a free iounit
      inunit = 0
      opn = .TRUE.
      DO WHILE (opn)
         inunit = inunit + 1
         INQUIRE(inunit, OPENED = opn)
      END DO

      open(inunit, file=file_list, IOSTAT = ios)
      if ( ios .NE. 0 ) then
         WRITE(*,*) 'Error in: Main_GPCPcdr_d2_GPROFv2004'//
     &            'Failed to open input ASCII file'
         STOP
      endif



c     ******************************************************
c     Read each filename and process

      do while (ios .EQ. 0)
         read(inunit,'(A)', IOSTAT = ios) input_file
         if ( ios .NE. 0 .AND. ios .NE. -1 ) then
            WRITE(*,*) 'Error in Main_GPCPcdr_d2_GPROFv2004:'//
     &             'Failed to read input ASCII file'
            STOP
         endif


         print *, "Processing: "//input_file

c        Call retrieval code
         call retrieval(input_file, GPROFPath)



c     Close loop over files
      end do

c     Close file
      close(inunit, IOSTAT = ios)
      if ( ios .NE. 0 ) then
         WRITE(*,*) 'Error in: Main_GPCPcdr_d2_GPROFv2004'//
     &            'Failed to close input ASCII file'
         STOP
      endif





      end program Main_GPCPcdr_d2_GPROFv2004


