        
	 ! Number of pixels per scan line
	 integer		NPIX
	 parameter	(NPIX = 128)

	 ! Number of channels
	 integer		NCHAN
	 parameter	(NCHAN = 7)

         ! max_scan for one orbit of TMI data
	 ! This may need to be changed for SSMIS...
         integer*4   MAX_SCANS
         parameter    (MAX_SCANS = 3400)    ! RSS SSMI data
         !parameter   (MAX_SCANS = 10000)   ! RSS SSMIS data
         !parameter   (MAX_SCANS = 8000)    ! file size 14416000  <== 8000/2*3604
         !parameter   (MAX_SCANS = 13102)  ! file size 23609804  <== 13102/2*3604

         ! Number of vertical layers
	 integer		NLYR
	 parameter	(NLYR = 14)

         ! Number of water databases with rainfall profiles
	 integer		DB_WATER
	 parameter	(DB_WATER = 1)

	 ! Number of land databases with rainfall profiles
	 integer		DB_LAND
	 parameter	(DB_LAND = 1)

	 ! Number of coast databases with rainfall profiles
	 integer		DB_COAST
	 parameter	(DB_COAST = 1)

        ! Number of profiles in each rainfall database
        integer     DBW_MXPROFILE
        parameter   (DBW_MXPROFILE = 13000)
        integer     DBL_MXPROFILE
        parameter   (DBL_MXPROFILE = 150)

        ! Dimensions of the grid
        integer nlon,nlat,nlonpr,nlatpr
        real*4 slat,elat,slon,elon
        parameter(nlon=144,nlat=32)
        parameter(slat=-40,elat=40,slon=-180,elon=180)

        ! Convective/stratiform weighting coefficients
      real*4    cint,c10v,c37v,c85v,cpd,cnpd,csd,cbob,csslope,csint
      parameter (cint=-84.8,c10v=1.11,c37v=-1.24,c85v=0.485,cpd=-1.25)
      parameter (cnpd=0.21,csd=1.24,cbob=0.143,csint=0.062,
     &csslope=0.00887)

        ! Number of channels (Tb) in database
        integer         DB_NCHAN
	parameter	(DB_NCHAN = 7)

        ! Number of channels (Variability) in database
        integer         DB_NVAR
	 parameter	(DB_NVAR = 1)

        ! Number of rings in database
        integer     NRING
        parameter   (NRING = 4)

        ! Number of emission index in database
        integer     NEMIS
        parameter   (NEMIS = 3)
      
        ! Number of scattering index in database
        integer     NSCAT
        parameter   (NSCAT = 2)

        ! Number of convective/stratiform classifications in database
        integer     NCSTYPE
        parameter   (NCSTYPE = 3)

        ! location of databases
        character DBPATH*44
        parameter(DBPATH='GPCPcdr_d2/GPCPcdr_d2_GPROFv2004_SSMI/DBASE/')

        ! Values of missing data for byte, integer and real
        integer     MISS_BYT
        parameter   (MISS_BYT = -99)
        integer     MISS_INT
        parameter   (MISS_INT = -9999)
        real        MISS_FLT
        parameter   (MISS_FLT = -9999.9)
  
        ! Logical flag for writing error messages to screen
        logical do_debug
        parameter (do_debug = .FALSE.)

        ! number of bytes in each scan line
        integer  SCAN_LENGTH
        parameter (SCAN_LENGTH=3604)
		
        !hdf-eos related parameters
        integer DFACC_CREATE
        parameter (DFACC_CREATE=4)
 
        integer   DFNT_INT16
        parameter ( DFNT_INT16=22  )
        integer   DFNT_INT32
        parameter(DFNT_INT32 = 24)
 
        integer   DFNT_FLOAT32
        parameter ( DFNT_FLOAT32=5 )
        integer   DFNT_FLOAT64
        parameter ( DFNT_FLOAT64=6 )
 
        integer         HDFE_DEG_DMS
        parameter       (HDFE_DEG_DMS=3)
 
        integer         GCTP_GEO
        parameter       (GCTP_GEO=0)
	
	character*2	INPUT_DIR
	parameter (INPUT_DIR='./')	

	!character*36	OUTPUT_DIR
	character*2	OUTPUT_DIR
	!parameter (OUTPUT_DIR='/snow/nelkin/SSMI/GPROF2004V/OUTPUT/')
	parameter (OUTPUT_DIR='./')
