      ! Ye Hong   09/08/97   Removed stdtime and changed channel numbers to TMI
      ! 5/02		      - Replaced NBUFF and NCORE with MAX_SCANS
      ! 3/03  added an additional ice screen
      ! 11/03 Removed all ice screens other than ice screen from Thorsten Markus

      ! Screening routine ice, possible (pack) ice.  Note that ice
      ! can occur over any surface type.  sfckind determines if sea ice 
      ! is possible.

      subroutine screen_ice(nwork, Tc, sfctype, sfckind, 
     &            pixel_status, rain_status)

      implicit none

      include 'parameters.inc'

      integer     nwork
      real        Tc(NPIX, MAX_SCANS, NCHAN)
      integer*1   sfctype(NPIX, MAX_SCANS)
      integer*1   sfckind(NPIX, MAX_SCANS)
      integer*2   pixel_status(NPIX, MAX_SCANS)
      integer*2   rain_status(NPIX, MAX_SCANS)

      integer     lin, pix

      logical     app_sfc
      real        T19V, T37V
      real        d85_37, gr3719

      integer     MASKI

c     Set values for screens that will be used for rain_status.
c     Masks imply that no rain is possible so mask values < 0.

      MASKI = -31

c     Set threshold values needed by the screening algorithm
c     The added values are for Tbs.

      do lin = 1, nwork
        do pix = 1, NPIX
           if ( pixel_status(pix,lin) .lt. 0 ) goto 10

           ! Identify applicable surfaces.  This screen is
           ! for ice surfaces only.

           app_sfc = .FALSE.
           if (sfckind(pix,lin) .EQ. 13) app_sfc = .TRUE.  
           if (sfckind(pix,lin) .EQ. 04) app_sfc = .TRUE.  
           if ((sfckind(pix,lin) .EQ. 27) .and.
     &         (sfctype(pix,lin) .EQ. 0)) app_sfc = .TRUE.

           if ( app_sfc ) then

              T19V = Tc(pix,lin,4)  
              T37V = Tc(pix,lin,7)

              gr3719 = (T37V - T19V)/(T37V + T19V)
              if (gr3719 .lt. 0.05) then
                 rain_status(pix,lin) = MASKI
              endif
           endif
  10    end do
      end do
      return
      end


