cejn  subroutine surface_db93_petty (start_line, nfound,  
      subroutine surface_db93_petty (nfound,
     &                sfmask2, lat, lon, sfctype, sfckind )
      ! Modifications:
      ! Removed NCORE and NBUFF.  Replaced with MAX_SCANS	5/02

      implicit none

      include 'parameters.inc'

*chiu/
      logical lsinit
      byte lsflag(2160,1080)
      common/ls/lsflag,lsinit
*chiu/

cejn  integer     start_line, nfound
      integer     nfound
      integer*1   sfmask2(1440,720)
      real        lat(NPIX, MAX_SCANS)   
      real        lon(NPIX, MAX_SCANS)
      real        alat, alon  	!chiu
      integer*1   sfctype(NPIX, MAX_SCANS)
      integer*1   sfckind(NPIX, MAX_SCANS)
      byte	  igetlandsea  !chiu

      integer     lin, pix
      integer     ilat, ilon


c     sfmask has the correct values:
c     0 = ocean; 1 = land; 2 = coast; 3 = other

cejn  do lin = start_line, start_line+nfound-1
cejn debug
c       write(*,*) 'In surface-db93-petty, nfound = ', nfound
      do lin = 1, nfound
c       write(*,*) 'lin, nfound = ', lin, nfound
        do pix = 1, NPIX
         
          alat = lat(pix,lin) 	!chiu
          alon = lon(pix,lin)		!chiu
          ilat = 1 + nint(4.0 * (alat + 89.875))
          if ( alon .ge. 0. ) then
            ilon = 1 + nint(4.0 * (alon - 0.125))
          else
            ilon = 1 + nint(4.0 * (alon + 359.875))
          endif
          if ((ilat .lt. 1) .or. (ilat .gt. 720) .or.
     $       (ilon .lt. 1) .or. (ilon .gt. 1440))  then
            sfctype(pix,lin) = -9	
            sfckind(pix,lin) = -9
          else
*           sfctype(pix,lin) = sfmask1(ilon, ilat)	!chiu
*incorporate land/sea mask of Petty
	    sfctype(pix,lin) = igetlandsea(alat,alon)   !chiu
            sfckind(pix,lin) = sfmask2(ilon, ilat)
          endif
c          write(*,*)sfctype(pix,lin),sfckind(pix,lin),pix,lin
        end do
      end do

      return
      end

************************************************************************
*     This module provides a convenient interface to the 1/6 deg
*     resolution land/sea mask of G. Petty.  Simply call the function
*     igetlandsea(alat,alon).  The returned value will be 0 for water, 1
*     for land, 2 for coast, 3 for permanent ice
*
*     Note the possible need to modify the unit number for reading the
*     data base file (see parameter IU) and/or the path to the data base
*     as set in the parameter DBPATH
*     
*     Version 1.0   6 April 2001  by G.W. Petty (gpetty@aos.wisc.edu)
*
*     Modifications: 
*     Removed NCORE and NBUFF.  Replaced with MAX_SCANS	5/02
*
*      program test
*
* 1    write(*,*)' Enter lat,lon: '
*      read(*,*)alat,alon
*      i = igetlandsea(alat,alon)
*      write(*,*)i
*      goto 1
*      end
*



* Initialize flag indicating whether
* Land/sea mask has been loaded

      block data landsea
      logical lsinit
      byte lsflag(2160,1080) 
      common/ls/lsflag,lsinit
      data lsinit/.false./
      end

* ------------------------------------------
* Load global land/sea mask into memory

      subroutine initlandsea

      implicit none

      include 'parameters.inc'		!Chiu

      logical lsinit
      byte lsflag(2160,1080) 
      common/ls/lsflag,lsinit

* following value may need to be changed to avoid conflicts in calling program
      integer   IU
      parameter (IU=21)
      character fname*256
      integer   i, j      

      fname = DBPATH//'igeomask_petty.asc'
      open(IU, file = fname,
     &     form='formatted',err=999,status='OLD')
      read(IU, *, err = 999)((lsflag(i,j),i=1,2160), j=1,1080)
      close(IU) 
      lsinit = .true.
      return

 999  continue
      write(*,*)'Error opening or reading land/sea file ',fname
      stop
      end

* -------------------------------------------------------------
* For a given lat/lon pair, return a value indicating the 
* dominant surface type within a radius of several km.  
*
*     LAND          0  (less than 5% water within ~20 km radius)
*     VEGET         1  (not used)
*     ---           2  (not used)
*     ICE           3
*     POSS_ICE      4
*     WATER         5  (less than 5% land within ~20 km radius)
*     COASTAL WATER 6  (more than 5% land within ~20  km radius)
*     VOID          7  (not used)
*     COASTAL LAND  8  (more than 5% water within ~20 km radius)

      byte function igetlandsea(rlat, rlon) 

      implicit none

      real rlat,rlon 

      byte    iflag
      logical lsinit
      byte    lsflag(2160,1080) 
      common/ls/lsflag,lsinit

      integer i,j
      if (.not. lsinit) call initlandsea 

      if (rlon .lt. 0.0) rlon = rlon + 360.0 
      if (rlon .ge.  360.0) rlon = rlon - 360.0 
      i = rlon*6.0  + 1
      j = (rlat + 90.0)*6.0 + 1
      iflag =  lsflag(i,j)

* optional:  translate to conventions used in GPROF
* (delete if not wanted)

      if (iflag .eq. 5 .or. iflag .eq. 4) then   ! ocean
         igetlandsea = 0
      else if (iflag .eq. 0) then                ! land
         igetlandsea = 1
      else if (iflag .eq. 6 .or. iflag .eq. 8) then   ! coast
         igetlandsea = 2
      else
         igetlandsea = 3                         ! other
      endif
      return
      end


