      ! Calculates the emission and scattering indeces for the
      ! database's ocean profiles.

      subroutine dbw_emis_scat_Index(dbw_nprofiles, 
     $         dbw_Tb, dbw_Tbclr, dbw_emisIndex, dbw_scatIndex)  

      implicit none
      include 'parameters.inc'

      integer     dbw_nprofiles(DB_WATER)
      real        dbw_Tb(DB_WATER,DBW_MXPROFILE,DB_NCHAN)
      real        dbw_Tbclr(DB_WATER,DBW_MXPROFILE,DB_NCHAN)
      real        dbw_emisIndex(DB_WATER,DBW_MXPROFILE,NEMIS)
      real        dbw_scatIndex(DB_WATER,DBW_MXPROFILE,NSCAT)
      integer     id, prof

      do id = 1, DB_WATER
         do prof = 1, dbw_nprofiles(id)
            ! In modified version, use clear-air background from 
            ! clear-air model simulations
            dbw_emisIndex(id,prof,1) = (dbw_Tb(id,prof,2) -
     +          dbw_Tb(id,prof,1))/
     +         (dbw_Tbclr(id,prof,2) - dbw_Tbclr(id,prof,1))
            dbw_emisIndex(id,prof,2) = (dbw_Tb(id,prof,5) -  
     +          dbw_Tb(id,prof,4))/
     +         (dbw_Tbclr(id,prof,5) - dbw_Tbclr(id,prof,4))
            dbw_emisIndex(id,prof,3) = (dbw_Tb(id,prof,7) -  
     +          dbw_Tb(id,prof,6))/
     +         (dbw_Tbclr(id,prof,7) - dbw_Tbclr(id,prof,6))
     
            dbw_scatIndex(id,prof,1) = 
     +          dbw_emisIndex(id,prof,2)*dbw_Tbclr(id,prof,5) +
     +         (1-dbw_emisIndex(id,prof,2))*273. -
     +          dbw_Tb(id,prof,5)
            dbw_scatIndex(id,prof,2) = 
     +          dbw_emisIndex(id,prof,3)*dbw_Tbclr(id,prof,7) +
     +         (1-dbw_emisIndex(id,prof,3))*273. -
     +          dbw_Tb(id,prof,7)
         end do
      end do

      return
      end
