

% code to check 
cd /home/msapiano/GPCP_CDR/GPCPv2p2_CDR_may12/daily/GPCPcdr_d2/GPCPcdr_d2_GPROFv2004/test
path(path,'/home/msapiano/matlab_functions');
load coast; coast_lat=lat; coast_long=long; clear lat long;


% read Bolvin data
fname='/home/msapiano/GPCP_CDR/GPCPv2p2_CDR_may12/daily/GPCPcdr_d2/GPCPcdr_d2_GPROFv2004/test/200401F13/GPROF2004V.F13.20040101_012918_20040101_030550';
clear a; fid=fopen(fname,'r','ieee-be'); fseek(fid,4,0);
a.start_time=fread(fid,6,'integer*4'); fseek(fid,8,0);
a.gridH_time=fread(fid,[360 720],'integer*1'); fseek(fid,8,0);
a.gridH_sfcrain=fread(fid,[360 720],'integer*2'); fseek(fid,8,0);
a.gridH_ncount=fread(fid,[360 720],'integer*1'); fseek(fid,8,0);
a.gridH_nambig=fread(fid,[360 720],'integer*1'); fseek(fid,8,0);
a.gridH_nrpix=fread(fid,[360 720],'integer*1'); fseek(fid,4,0);
fclose(fid);
gsfc=a;





% read corresponding CDR file
fname='/data/radler/msapiano/GPCP_CDR_Data/GPCP_Interim/GPROF2004V/0401/GPROF2004V.F13.20040101_012918_20040101_030345';



clear a;
fid=fopen(fname,'r');
fseek(fid,4,0);
a.start_time=fread(fid,6,'integer*4');
fseek(fid,8,0);
a.gridH_time=fread(fid,[360 720],'integer*1');
fseek(fid,8,0);
a.gridH_sfcrain=fread(fid,[360 720],'integer*2');
fseek(fid,8,0);
a.gridH_ncount=fread(fid,[360 720],'integer*1');
fseek(fid,8,0);
a.gridH_nambig=fread(fid,[360 720],'integer*1');
fseek(fid,8,0);
a.gridH_nrpix=fread(fid,[360 720],'integer*1');
fseek(fid,4,0);
fclose(fid);
cdr=a;



% make plots comparing fields

clf;
subplot 531; imagesc(cdr.gridH_time); colorbar('h');
subplot 532; imagesc(gsfc.gridH_time); colorbar('h');
subplot 533; imagesc(gsfc.gridH_time-cdr.gridH_time); colorbar('h');

cdr.gridH_sfcrain(find(cdr.gridH_sfcrain<-999))=NaN;
gsfc.gridH_sfcrain(find(gsfc.gridH_sfcrain<-999))=NaN;
subplot 534; imagesc(cdr.gridH_sfcrain); caxis([-10 100]); colorbar('h');
subplot 535; imagesc(gsfc.gridH_sfcrain); caxis([-10 100]); colorbar('h');
subplot 536; imagesc(gsfc.gridH_sfcrain-cdr.gridH_sfcrain); colorbar('h');

subplot 537; imagesc(cdr.gridH_ncount); colorbar('h');
subplot 538; imagesc(gsfc.gridH_ncount); colorbar('h');
subplot 539; imagesc(gsfc.gridH_ncount-cdr.gridH_ncount); colorbar('h');

subplot(5,3,10); imagesc(cdr.gridH_nambig); colorbar('h');
subplot(5,3,11); imagesc(gsfc.gridH_nambig); colorbar('h');
subplot(5,3,12); imagesc(gsfc.gridH_nambig-cdr.gridH_nambig); colorbar('h');

subplot(5,3,13); imagesc(cdr.gridH_nrpix); colorbar('h');
subplot(5,3,14); imagesc(gsfc.gridH_nrpix); colorbar('h');
subplot(5,3,15); imagesc(gsfc.gridH_nrpix-cdr.gridH_nrpix); colorbar('h');

set(gcf,'PaperPosition',[0.25 2.5 20 30]);
print('-dpng','test');



