	SUBROUTINE SWAPI23D  ( idatain, LN, LT, NLAY )
C***********************************************************************
C* SWAPI23D  Byte swap an INTEGER*2 3D array			       *
C*								       *
C* SWAPI2 swaps the bytes of an INTEGER*2 3D array.  This was          *
C* implemented to maintain the big-endian output when porting to       *
C* LINUX.							       *
C*								       *
C* SWAPI23D  ( idatain, LN, LT, NLAY )				       *
C*								       *
C* Input Parameters:						       *
C*								       *
C*  idatain	INT*2	Array to be byte swapped		       *
C*  LN		INT	Longitude array size			       *
C*  LT		INT	Latitude array size			       *
C*  NLAY	INT	Number of layers			       *
C* 								       *
C* Output Parameters:						       *
C* 								       *
C*  idatain	INT*2	Byte-swapped array			       *
C*								       *
C**								       *
C* Log:								       *
C* D.Bolvin/SSAI	 04/11	First version			       *
C***********************************************************************
C
	IMPLICIT	NONE
C
	INTEGER*4	i, LN, LT, NLAY
C
	INTEGER*2	idatain (LN*LT*NLAY)
C
        INTEGER*2	varin, var
        INTEGER*2       idata (LN*LT*NLAY)
C
        CHARACTER*1	cvarin (2), cvar (2)
C
	EQUIVALENCE (cvarin, varin)
	EQUIVALENCE (cvar,   var)
C
C***********************************************************************
C	Swap the bytes.
C
	DO i = 1, LN * LT * NLAY
	    varin = idatain (i)
	    cvar (1) = cvarin (2)
	    cvar (2) = cvarin (1)
	    idata (i) = var
	END DO
C
C***********************************************************************
C	Replace the unswapped bytes in the original array with the 
C	swapped bytes.
C
	DO i = 1, LN * LT * NLAY
	    idatain (i) = idata (i)
	END DO
C
	RETURN 
	END
	
