	SUBROUTINE SWAPI4  ( idatain, LN, LT )
C***********************************************************************
C* SWAPI4  Byte swap an INTEGER*4 array				       *
C*								       *
C* SWAPI4 swaps the bytes of an INTEGER*4 array.  This was implemented *
C* to maintain the big-endian output when porting to LINUX.	       *
C*								       *
C* SWAPI4  ( idatain, LN, LT )					       *
C*								       *
C* Input Parameters:						       *
C*								       *
C*  idatain	INT*4	Array to be byte swapped		       *
C*  LN		INT	Longitude array size			       *
C*  LT		INT	Latitude array size			       *
C* 								       *
C* Output Parameters:						       *
C* 								       *
C*  idatain	INT*4	Byte-swapped array			       *
C*								       *
C**								       *
C* Log:								       *
C* D.Bolvin/SSAI	 04/11	First version			       *
C***********************************************************************
C
	IMPLICIT	NONE
C
	INTEGER*4	i, LN, LT
C
	INTEGER*4	idatain (LN*LT)
C
        INTEGER*4	varin, var
        INTEGER*4       idata (LN*LT)
C
        CHARACTER*1	cvarin (4), cvar (4)
C
	EQUIVALENCE (cvarin, varin)
	EQUIVALENCE (cvar,   var)
C
C***********************************************************************
C	Swap the bytes.
C
	DO i = 1, LN * LT
	    varin = idatain (i)
	    cvar (1) = cvarin (4)
	    cvar (2) = cvarin (3)
	    cvar (3) = cvarin (2)
	    cvar (4) = cvarin (1)
	    idata (i) = var
	END DO
C
C***********************************************************************
C	Replace the unswapped bytes in the original array with the 
C	swapped bytes.
C
	DO i = 1, LN * LT
	    idatain (i) = idata (i)
	END DO
C
	RETURN 
	END
	
