      
C     
C     Top of main loop.  Start by accumulating total histogram and 
C     coldest Tb of IR with the implicit assumption that the IR handed 
C     in are approximately the month of interest.  Do the ZA 
C     correction (and shift to 1K bins) on the IR Tb (stored for use 
C     in the maatching below), then accumulate it.  Unlike the code 
C     for ntbcum (below) there is no weighting by HQ population.  
C     Also, accumulate the leo-IR precipitation PDF.
C     
      DO  WHILE ( ( active (1) .OR. active (2) .OR. active (3) .OR.
     +     active (4) ) .AND. iir .GT. 0 )
c     insat
c     DO  it = 1, LBIN
c     DO  j  = 1, LT
c     DO  i  = 41, 90
c            ltb (i, j, it) = 0
c          END DO
c     END DO
c     END DO
c     insat
         CALL ZA_TB  ( LN, LT, LBIN, ltb, lza, -1, -1, -1, 'none',
     +        ntbh,   iret )
         IF  ( iret .NE. 0 )  STOP
c     test
c     test      Flip and accumulate the low-res., un-ZA-corr. bins, then for
c     test      gridboxes with data normalize to 1000 total, find the first
c     test      non-zero box, and accumulate statistics in the 230-240 range
c     test      when the first non-zero box value is in that range.
c     test
c     DO  j = 1, LT
c     DO  i = 1, LN
c     ltbcum (1) = ltb (i, j, LBIN)
c          DO  it = 1, 23
c            ltbcum (it+1) = ltb (i, j, LBIN-it) + 
c     +                        ltbcum (it)
c          END DO
c          IF  ( ltbcum (LBIN) .GT. 0 )  THEN
c            DO  it = 1, LBIN
c                ltbcum (it) = 10000. * FLOAT ( ltbcum (it  ) ) / 
c     +                                 FLOAT ( ltbcum (LBIN) )
c            END DO
c            it1 = 1
c            DO  WHILE ( ltbcum (it1) .EQ. 0 )
c                it1 = it1 + 1
c            END DO
c            IF  ( it1 .GT. 7 .AND. it1 .LT. 18 )  THEN
c                it = it1
c                DO  WHILE ( it .LT. 18 )
c                  c00  (it-it1+1) = c00    (it-it1+1) + 
c     +                                ltbcum (it)
c                  c002 (it-it1+1) = c002   (it-it1+1) + 
c     +                                ltbcum (it) * ltbcum (it)
c                  nc00 (it-it1+1) = nc00   (it-it1+1) + 1
c                  it = it + 1
c                END DO
c            END IF
cC
c            it1 = 1
c            DO  WHILE ( ltbcum (it1+1) - 5000 .LT. 
c     +                      5000 - ltbcum (it1) )
c                it1 = it1 + 1
c            END DO
c            IF  ( it1 .GT. 6 .AND. it1 .LT. 18 )  THEN
c                it = 7
c                DO  WHILE ( it .LT. 18 )
c                  c50  (it-it1+11) = c50    (it-it1+11) + 
c     +                                 ltbcum (it)
c                  c502 (it-it1+11) = c502   (it-it1+11) + 
c     +                                 ltbcum (it) * ltbcum (it)
c                  nc50 (it-it1+11) = nc50   (it-it1+11) + 1
c                  it = it + 1
c                END DO
c            END IF
c          END IF          
c      END DO
c      END DO
ctest
         DO  j = 1, LT
            DO  i = 1, LN
               IF  ( lza (i, j) .GE. 0 .AND. lza (i, j) .LE. 900 ) THEN
                  DO  it = 189, 270
                     ntbtot (it, i, j) = ntbtot (it, i, j) +
     +                    ntbh   (it, i, j)
                  END DO
                  DO  it = 189, 270
                     IF  ( ntbh (it, i, j) .GT. 0 )  THEN
                        ngstrt (it, i, j) = ngstrt (it, i, j) + 1
                        GO TO 15
                     END IF
                  END DO
 15               CONTINUE
               END IF
            END DO
         END DO
         DO  j = 1, LT
            DO  i = 1, LN
               IF  ( leop (i, j) .GE. 0 )  THEN
                  npdf  (             i, j) = npdf  (i, j) + 1
                  pdf   (npdf (i, j), i, j) = leop  (i, j) * .01
               END IF
            END DO
         END DO
C     
C     Top of loop for each HQ.  If the HQ is active, start by
C     setting HQ time field relative to IR time field.  It was
C     checked above that mismatches between IR and HQ times 
C     are less than a year.
C
         DO  m = 1, MXHQ
            IF  ( active (m) )  THEN
 20            IF  ( jyrhq (m) .NE. jyrir )  THEN
                  IF  ( MOD ( jyrhq (m), 4 ) .EQ. 0 )  THEN
                     jdiff = 366 * ( jyrhq (m) - jyrir )
                  ELSE
                     jdiff = 365 * ( jyrhq (m) - jyrir )
                  END IF
                  jyrhq  (m) = jyrir
                  jdayhq (m) = jdayhq (m) + jdiff
               END IF
               IF  ( jdayhq (m) .NE. jdayir )  THEN
                  jdiff      = 1440 * ( jdayhq (m) - jdayir )
                  IF  ( jdiff .LT. I2MISS )  THEN
                     IF  ( m .LE. 3 )  THEN
                        WRITE (*, *) 'Error: start time for ',sname(ihq(m),m), 
     +                       ' must be closer to IR start time than', I2MISS,
     +                       ' minutes, but appears to be', jdiff
                     ELSE
                        WRITE (*, *) 'Error: start time for ', tname (ihq(m)), 
     +                       ' must be closer to IR start time than', I2MISS,
     +                       ' minutes, but appears to be', jdiff
                     END IF
                     STOP
                  END IF
                  jdayhq (m) = jdayir
                  DO  j = 1, LT
                     DO  i = 1, LN
                        IF  ( jminhq (i, j, m) .NE. I2MISS ) 
     +                       jminhq (i, j, m) = jminhq (i, j, m) + 
     +                       jdiff
                     END DO
                  END DO
               END IF
C     
C     Compute coincidence as 90 min either side of the
C                nominal IR time.  The order of IFs is chosen such 
C                that the most common missings come first.  The 
C                first jminhq test also catches non-existent GPROF 
C                (most of the field).  "More" flags the existance of 
C                HQ data that should match up with the next IR field.
C                A valid ZA is a convenient flag of the  geo-IR
C                existing.  All of the HQ is accumulated for use
C                with low-orbit.
C
C      OPEN (20, FILE = 'lza.bin', FORM = 'UNFORMATTED',
C     +            ACCESS = 'DIRECT', RECL = 14400)
C           WRITE (20, REC = 1) lza
C      CLOSE (20)
C      STOP
C
               more = .FALSE.
               DO  j = 1, LT
                  DO  i = 1, LN
                     IF  ( jminhq (i, j, m) .LE. 
     +                    ( jminir - 90 ) )  THEN
                     ELSE IF  ( jminhq (i, j, m) .GT. 
     +                       ( jminir + 90 ) )  THEN
                        more = .TRUE.
                     ELSE IF  ( lza (i, j) .LT. 0 .OR.
     +                       lza (i, j) .GT. 900 )  THEN
                        IF  ( hq_f (i, j, m) .GT. 0. )
     +                       fcums (i, j) = fcums (i, j) + 
     +                       jhq_n (i, j, m)
                        ncums (i, j) = ncums (i, j) + jhq_n (i, j,m)
                        ncumas(i, j) = ncumas(i, j) + jhq_a (i, j,m)
                        pcum3 (i, j) = pcum3 (i, j) + 
     +                       hq_p (i, j, m) * jhq_n (i, j, m) * 24.
                        ncuma3(i, j) = ncuma3(i, j) + jhq_a (i, j,m)
                        ncum3 (i, j) = ncum3 (i, j) + jhq_n (i, j,m)
C     
C     Do the ZA correction (and shift to 1K bins) 
C     on the IR Tb, then accumulate it, the HQ 
C                    precip and frequency of precip, and increment 
C                    the number-of-cases counter.  At this point
C                    the HQ is converted from mm/hr to mm/d.
C
                     ELSE
cxx   CALL ZA_TB  ( LN,   LT,  LBIN,   ltb, lza,
cxx   +                                i, j, ihr, 'none', ntbh, iret)
                        DO  it = 189, 270
                           ntbcum (it, i, j) = ntbcum (it, i, j) +
     +                          (INT (ntbh   (it, i, j)) * INT (jhq_n (i, j, m)))
                        END DO
                        pcum  (i, j) = pcum  (i, j) + 
     +                       hq_p (i, j, m) * jhq_n (i, j, m) * 24.
                        fcum  (i, j) = fcum  (i, j) +
     +                       hq_f (i, j, m) * jhq_n (i, j, m)
                        ncum  (i, j) = ncum  (i, j) + jhq_n (i, j,m)
                        IF  ( hq_f (i, j, m) .GT. 0. )
     +                       fcums (i, j) = fcums (i, j) + 
     +                       jhq_n (i, j, m)
                        ncums (i, j) = ncums (i, j) + jhq_n (i, j,m)
                        pcum3 (i, j) = pcum3 (i, j) + 
     +                       hq_p (i, j, m) * jhq_n (i, j, m) * 24.
                        ncuma3(i, j) = ncuma3(i, j) + jhq_a (i, j,m)
                        ncum3 (i, j) = ncum3 (i, j) + jhq_n (i, j,m)
                        ncumas(i, j) = ncumas(i, j) + jhq_a (i, j,m)
                        ncuma (i, j) = ncuma (i, j) + jhq_a (i, j,m)
                     END IF
                  END DO
               END DO
C     
C     Done with this HQ for this IR.  If there aren't HQ
C                times past the end of the IR, get the next file
C                for this satellite (if one exists) and jump back
C                to process it.
C     
               IF  ( .NOT. more )  THEN
                  ihq (m) = ihq (m) + 1
                  IF  ( ( ihq (m) .GT. nss (m) .AND. m .LE. 3 ) 
     +                 .OR. 
     +                 ( ihq (m) .GT. nt      .AND. m .EQ. 4 ) )  
     +                 THEN
                     active (m) = .FALSE.
                  ELSE
                     IF  ( m .LE. 3 )  THEN
                        CALL GET_GORB ( 
     +                       sname  (ihq (m), m), histo, histl, 
     +                       jyrhq (m),        jdayhq (m),
     +                       jminhq (1, 1, m), 
     +                       hq_p   (1, 1, m), hq_f  (1, 1, m), 
     +                       jhq_n  (1, 1, m), jhq_a (1, 1, m),
     +                       iret )
                     ELSE
                        CALL GET_GORB ( 
     +                       tname  (ihq (m)), -1., -1., 
     +                       jyrhq (m),        jdayhq (m),
     +                       jminhq (1, 1, m), 
     +                       hq_p   (1, 1, m), hq_f  (1, 1, m), 
     +                       jhq_n  (1, 1, m), jhq_a (1, 1, m),
     +                       iret )
                        IF  ( iret .EQ. 0 )  THEN
                           DO  j = 1, LT
                              DO  i = 1, LN
                                 jhq_n (i, j, m) = NINT ( jhq_n (i, j, m) * T_TO_S )
                              END DO
                           END DO
                        END IF
                     END IF
                     IF  ( iret .LT. 0 )  THEN
                        active (m) = .FALSE.
                     ELSE
                        GO TO 20
                     END IF
                  END IF
               END IF
C     
            END IF
         END DO
C
C          Done looping through each HQ satellite.  If at least one
C          is still active and the next IR exists, get the next IR
C          field.  This is the end of the main accumulation loop.
C          First, audit the 3-hly HQ for ambiguous, dump them out,
C          and reset the accumulation registers.
C
         DO  j = 1, LT
            DO  i = 1, LN
               IF  ( ncum3 (i, j) .GT. 0 )  THEN
                  IF  ( FLOAT ( ncuma3 (i, j) ) / 
     +                 FLOAT ( ncum3  (i, j) ) .LT. .4 )  THEN
                     pcum3 (i, j) = pcum3 (i, j) / FLOAT (ncum3 (i, j))
                  ELSE
                     pcum3 (i, j) = RMISS
                  END IF
               ELSE
                  pcum3 (i, j) = RMISS
               END IF
            END DO
         END DO
C     
C          Build a temporary basename by appending the (presumed) date 
C          in the IR filename and the hour number to the basename, and 
C          dump out 3-hrly HQ field.
C
         CALL ST_LSTR ( iname (iir), l_ir, iret )
         IF  ( iname (iir) (l_ir:l_ir) .EQ. 'Z' )  THEN
            l_ir = l_ir - 2
         ELSE IF  ( iname (iir) (l_ir-1:l_ir) .EQ. 'gz' )  THEN
            l_ir = l_ir - 3
         END IF
         WRITE ( c_hr, 910 )  ( ihr - 1 ) * 3
 910     FORMAT ( I2.2 )
         tbas = fbas (1:l_fbas) // '.' // 
     +        iname (iir) (l_ir-7:l_ir) // c_hr
C     
         CALL DMPIMGF  ( pcum3, tbas, 'pcum3', .FALSE., LN, LT, iret)
C     
         DO  j = 1, LT
            DO  i = 1, LN
               pcum3  (i, j) = 0.
               ncum3  (i, j) = 0
               ncuma3 (i, j) = 0
            END DO
         END DO
C     
         IF  ( active (1) .OR. active (2) .OR. active (3) .OR.
     +        active (4) )  THEN
            CALL GET_IRTB ( iname,  nir,    iir, ihr, jyrir, 
     +           jdayir, jminir, ltb, lza, igeop,
     +           leop,   iret )
            IF  ( iret .NE. 0 )  STOP
         END IF
      END DO
      
      
