	SUBROUTINE SWAPR4  ( datain, LN, LT )
C***********************************************************************
C* SWAPR4  Byte swap a REAL*4 array				       *
C*								       *
C* SWAPR4 swaps the bytes of a REAL*4 array.  This was implemented to  *
C* maintain the big-endian output when porting to LINUX.	       *
C*								       *
C* SWAPR4  ( datain, LN, LT )					       *
C*								       *
C* Input Parameters:						       *
C*								       *
C*  datain	REAL*4	Array to be byte swapped		       *
C*  LN		INT	Longitude array size			       *
C*  LT		INT	Latitude array size			       *
C* 								       *
C* Output Parameters:						       *
C* 								       *
C*  datain	REAL*4	Byte-swapped array			       *
C*								       *
C**								       *
C* Log:								       *
C* D.Bolvin/SSAI	 04/11	First version			       *
C***********************************************************************
C
	IMPLICIT	NONE
C
	INTEGER*4	i, LN, LT
C
	REAL*4		datain (LN*LT)
C
        REAL*4		varin, var
        REAL*4	        data (LN*LT)
C
        CHARACTER*1	cvarin (4), cvar (4)
C
	EQUIVALENCE (cvarin, varin)
	EQUIVALENCE (cvar,   var)
C
C***********************************************************************
C	Swap the bytes.
C
	DO i = 1, LN * LT
	    varin = datain (i)
	    cvar (1) = cvarin (4)
	    cvar (2) = cvarin (3)
	    cvar (3) = cvarin (2)
	    cvar (4) = cvarin (1)
	    data (i) = var
	END DO
C
C***********************************************************************
C	Replace the unswapped bytes in the original array with the 
C	swapped bytes.
C
	DO i = 1, LN * LT
	    datain (i) = data (i)
	END DO
C
	RETURN 
	END
	
